<script type="text/javascript">
var InterfaceTapas = Class.create( {

    initialize: function( jsonFileFormats, jsonYesNos, jsonObservatories )
    {
        /** *********** CONTAINERS *********** **/
        this.containerForm = $( "#formulaire" );
        this.containerErrors = $( "#errors" );

        this.jsonFileFormats = jsonFileFormats || null;
        this.jsonYesNos = jsonYesNos || null;
        this.jSonObservatories = jsonObservatories || null;
        //this.jSonSelectUnits = jsonSelectUnits || null;

        this.containerErrors.hide();

        this.createForm();

    },



    // CREATES ********************************************************
    createCalendar: function( containerCalendar )
    {
        // Create input for date text
        var inputDateId = "iobservation_date";
        var inputDate = $( document.createElement( "input" ) );
        inputDate.attr( {id:inputDateId, size:"17"} );
        containerCalendar.append( inputDate );

        // Calendar
        this.calendarFormat = "%Y-%m-%d %H:%i:%s";
        this.calendarConverter = new AnyTime.Converter( { format: this.calendarFormat } );

        AnyTime.picker( inputDateId, { format: this.calendarFormat, firstDOW: 1,
            labelTitle: "Select Date", labelYear: "Year", labelMonth: "Month", labelDayOfMonth: "Day",
            labelHour: "Hour", labelMinute: "Minute", labelSecond: "Second"
        } );

        var currentDate = new Date();
        $( "#observationDate" ).val( this.calendarConverter.format( currentDate ) );
    },

    createTr: function( texte, inputId, container )
    {
        var tr = $( document.createElement( "tr" ) );
        var td1 = $( document.createElement( "td" ) );
        var td2 = $( document.createElement( "td" ) );
        var input = $( document.createElement( "input" ) );


        input.attr( {id: inputId} );
        td1.html( texte );
        tr.append( td1 );
        td2.append( input );
        tr.append( td2 );
        container.append( tr );
    },


    createTrList: function( texte, inputId, container, type )
    {
        var tr = $( document.createElement( "tr" ) );
        var td1 = $( document.createElement( "td" ) );
        var td2 = $( document.createElement( "td" ) );
        var input = $( document.createElement( "input" ) );

        input.attr( {id: inputId} );
        td1.html( texte );
        tr.append( td1 );
        if( type == 'format' ) this.displayFileFormats( td2 );
        else if( type == 'yesno' ) this.displayYesNo( td2, inputId );
        else if( type == 'observatories' ) this.displayObservatories( td2 );
        else if( type == 'spectralUnit' ) this.displaySpectralUnits( td2 );

        tr.append( td2 );
        container.append( tr );
    },


    createForm: function()
    {

        //Creation div / tab
        var divPreference = $( document.createElement( "div" ) );
        var tabPreference = $( document.createElement( "table" ) );

        var divObservation = $( document.createElement( "div" ) );
        var tabObservation = $( document.createElement( "table" ) );

        this.createTrList( "File format", "iformat", tabPreference, 'format' );
        this.createTr( "Rayleigh extinction", "irextinction", tabPreference );
        this.createTrList( "H20 extinction", "ih2oe", tabPreference, 'yesno' );
        this.createTrList( "O3 extinction", "io3e", tabPreference, 'yesno' );
        this.createTrList( "O2 extinction", "io2e", tabPreference, 'yesno' );
        this.createTrList( "CO2 extinction", "ico2e", tabPreference, 'yesno' );

        this.createTrList( "Observatory", "iobservatory", tabObservation, 'observatories' );



        this.createCalendar( tabObservation );



        this.createTr( "Right LOS ascension", "ira", tabObservation );
        this.createTr( "LOS declension", "ide", tabObservation );
        this.createTr( "Zenith angle", "iza", tabObservation );
        // this.createTrList("Spectral unit", "ispectral_choice", tabObservation, 'spectralUnit');
        this.createTr( "Spectral range", "ispectral_ranger", tabObservation );


        divPreference.append( tabPreference );
        this.containerForm.append( divPreference );

        divObservation.append( tabObservation );
        this.containerForm.append( divObservation );

        //jQuery.proxy permet d'envoyer le contexte this courant
        var submitButton = new Button( {value:tapasTexts["label.submitButton"], parent:this.containerForm, id:"button_submit", className: "red_button", classNameText:"red_button_text", onClick:jQuery.proxy( this.onClickSubmit, this )} );

    },



    // REQUESTS ********************************************************
    requestCreateXML: function()
    {
        var tapasForm = this.createTapasObject();
        //passage de javascript a json grace au jquery
        var jsonTapasForm = $.toJSON( tapasForm );

        if( jsonTapasForm )
            $.ajax( {
                url: "data?methodName=createUserRequest&jsonTapas=" + jsonTapasForm,
                success:jQuery.proxy( this.handleCreateXML, this ),
                error: jQuery.proxy( this.showErrors, this )
            } );
    },

    // HANDLES ******************************************************** = retours ajax
    handleCreateXML: function( result )
    {
        var bob = jQuery.parseJSON( result ).result;
        alert( bob );
    },


    // EVENTS ********************************************************
    onClickSubmit: function()
    {
        this.containerErrors.hide();
        this.requestCreateXML();
    },


    // OTHERS ********************************************************
    displayFileFormats: function( container )
    {
        var paramSelect = new Object();
        paramSelect.id = "select_formats";
        paramSelect.parent = container;
        this.selectFormats = new Select( paramSelect );
        jQuery.each( this.jsonFileFormats, jQuery.proxy( function ( i, jsonFileFormat )
        {
            this.selectFormats.add( jsonFileFormat.value, jsonFileFormat.text );
        }, this ) );
        this.selectFormats.selectFirst( false );
    },


    displayYesNo: function( container, name )
    {
        var paramSelect = new Object();
        paramSelect.id = "select_" + name;
        paramSelect.parent = container;
        this.selectYesNos = new Select( paramSelect );
        jQuery.each( this.jsonYesNos, jQuery.proxy( function ( i, jsonYesNo )
        {
            this.selectYesNos.add( jsonYesNo.value, jsonYesNo.text );
        }, this ) );
        this.selectYesNos.selectFirst( false );
    },


    displayObservatories: function( container )
    {
        var paramSelect = new Object();
        paramSelect.id = "select_observatory";
        paramSelect.parent = container;
        this.selectObservatories = new Select( paramSelect );
        //ajouter select vide avec add
        this.selectObservatories.add( "-1", "-- Select an observatory --" );
        jQuery.each( this.jSonObservatories, jQuery.proxy( function ( i, jsonObservatory )
        {
            this.selectObservatories.add( jsonObservatory.id, jsonObservatory.name );
        }, this ) );
        this.selectObservatories.selectFirst( true );
    },


    displaySpectralUnits: function( container )
    {
        var paramSelect = new Object();
        paramSelect.id = "select_spectral_unit";
        paramSelect.parent = container;
        this.selectSpectralUnits = new Select( paramSelect );
        //ajouter select vide avec add
        this.selectSpectralUnits.add( "-1", "-- Select unit --" );
        jQuery.each( this.jSonSpectralUnit, jQuery.proxy( function ( i, jsonSpectralUnit )
        {
            this.selectSpectralUnits.add( jsonSpectralUnit.id, jsonSpectralUnit.name );
        }, this ) );
        this.selectSpectralUnits.selectFirst( true );
    },

    showErrors: function( result )
    {
        this.containerErrors.show();
        this.containerErrors.html( tapasTexts[result.responseText] );
    },

    createTapasObject: function()
    {
        // PREFERENCE
        var preference = new Object();

        preference.format = new Object();
        //toutes les valeurs possibles
        //preference.format.firstValue = $( "#select_formats" ).val();
        preference.format.firstValue = this.selectFormats.getValues();
        //la valeur selectionnee
        preference.format.secondValue = this.selectFormats.getValue();


        var pair = new Object();
        pair.firstValue = "YES,NO";
        pair.secondValue = this.selectFormats.getValue();

        preference.rayleighExtinction = new Object();
        ;
        preference.h2oExtinction = pair;
        preference.o3Extinction = pair;
        preference.o2Extinction = pair;
        preference.co2Extinction = pair;

        // OBSERVATION
        // Observatory
        var observatory = new Object();
        //observatory.name = this.selectFormats.name;

        observatory.longitude = this.longitude.value;
        observatory.latitude = this.latitude.value;
        observatory.altitude = this.altitude.value;


        // Los
        var los = new Object();
        los.raJ2000 = "04:32:43";
        los.decJ2000 = "-43:12:10.22";

        los.zenithAngle = new Object();
        los.zenithAngle.min = "0";
        los.zenithAngle.max = "90";
        los.zenithAngle.value = 60;

        // Instrument
        var instrument = new Object();

        instrument.spectralChoice = new Object();
        instrument.spectralChoice.firstValue = "Vacuum Wavelength (nm),Standard Wavelength (nm),Wavenumber (cm-1)";
        instrument.spectralChoice.secondValue = "Standard Wavelength (nm)";
        instrument.spectralRange = "1180 1200";
        instrument.ilsfChoice = new Object();
        instrument.ilsfChoice.firstValue = "-1,0,1";
        instrument.ilsfChoice.secondValue = 0;
        instrument.ilsfPath = "/home/ferron/tmp/tapas/ilsf.txt";
        instrument.resolvingPower = new Object();
        instrument.resolvingPower.firstValue = "0";
        instrument.resolvingPower.secondValue = 1000000;
        instrument.samplingRatio = new Object();
        instrument.samplingRatio.firstValue = "0";
        instrument.samplingRatio.secondValue = 3;

        var observation = new Object();
        observation.date = this.calendarConverter.parse( $( "#iobservation_date" ).val() ).getTime();
        observation.observatory = observatory;
        observation.los = los;
        observation.instrument = instrument;

        // ATMOSPHERE
        var atmosphere = new Object();
        atmosphere.reference = new Object();
        atmosphere.reference.firstValue = "0,1,2,3,4,5,6";
        atmosphere.reference.secondValue = 6;

        atmosphere.arlettyFile = new Array();
        atmosphere.arlettyFile[0] = "/home/ferron/tmp/tapas/Reims_070402.ARL.txt";
        atmosphere.arlettyFile[1] = "/home/ferron/tmp/tapas/Reims_070402.ARL.txt22";

        atmosphere.ecmwfFile = new Array();
        atmosphere.ecmwfFile[0] = "/home/ferron/tmp/tapas/ecmwf12.txt";


        // REQUEST
        var request = new Object();
        request.id = 1;
        request.preference = preference;
        request.observation = observation;
        request.atmosphere = atmosphere;

        var requests = new Array();
        requests[0] = request;

        // TAPAS
        var tapas = new Object();
        tapas.id = "Ether_TAPAS_0000001";
        tapas.requests = requests;

        return tapas;
    }

} );


</script>
